﻿using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 고객
    /// </summary>
    public class Customer
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 고객 ID - CustomerID

        /// <summary>
        /// 고객 ID
        /// </summary>
        public string CustomerID { get; set; }

        #endregion
        #region 고객명 - CustomerName

        /// <summary>
        /// 고객명
        /// </summary>
        public string CustomerName { get; set; }

        #endregion
        #region 주문 리스트 - OrderList

        /// <summary>
        /// 주문 리스트
        /// </summary>
        public List<Order> OrderList { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 고객 리스트 구하기 - GetCustomerList()

        /// <summary>
        /// 고객 리스트 구하기
        /// </summary>
        /// <returns>고객 리스트</returns>
        public static List<Customer> GetCustomerList()
        {
            List<Customer> list = new List<Customer>();

            Customer customer1 = new Customer();

            customer1.CustomerID   = "001";
            customer1.CustomerName = "홍길동";
            customer1.OrderList    = new List<Order>();

                Order order1 = new Order();

                order1.OrderID         = "001";
                order1.OrderDate       = "2020-04-01";
                order1.OrderDetailList = new List<OrderDetail>();

                    OrderDetail orderDetail1 = new OrderDetail();

                    orderDetail1.OrderID   = "001";
                    orderDetail1.ProductID = "001";
                    orderDetail1.Quantity  = 10;
                    
                    order1.OrderDetailList.Add(orderDetail1);

                    OrderDetail orderDetail2 = new OrderDetail();

                    orderDetail2.OrderID   = "001";
                    orderDetail2.ProductID = "002";
                    orderDetail2.Quantity  = 50;
                    
                    order1.OrderDetailList.Add(orderDetail2);

                    OrderDetail orderDetail3 = new OrderDetail();

                    orderDetail3.OrderID   = "001";
                    orderDetail3.ProductID = "003";
                    orderDetail3.Quantity  = 20;
                    
                    order1.OrderDetailList.Add(orderDetail3);

                customer1.OrderList.Add(order1);

                Order order2 = new Order();

                order2.OrderID         = "002";
                order2.OrderDate       = "2020-04-03";
                order2.OrderDetailList = new List<OrderDetail>();

                    OrderDetail orderDetail4 = new OrderDetail();

                    orderDetail4.OrderID   = "002";
                    orderDetail4.ProductID = "001";
                    orderDetail4.Quantity  = 50;
                    
                    order2.OrderDetailList.Add(orderDetail4);

                customer1.OrderList.Add(order2);

            list.Add(customer1);

            return list;
        }

        #endregion
    }
}